Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 870280 - dev-lang/rust: can't compile on pure LLVM profiles (no sys-devel/gcc)
Summary: dev-lang/rust: can't compile on pure LLVM profiles (no sys-devel/gcc)
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Georgy Yakovlev
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: systemwide-clang systemwide-libcxx
  Show dependency tree
 
Reported: 2022-09-15 19:51 UTC by Sam James
Modified: 2022-09-16 00:55 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (file_870280.txt,9.83 KB, text/plain)
2022-09-15 19:51 UTC, Sam James
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-09-15 19:51:38 UTC
Created attachment 805405 [details]
build.log

>>> Source configured.
>>> Compiling source in /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rustc-1.63.0-src ...
Building rustbuild
running: /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo build --manifest-path /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rustc-1.63.0-src/src/bootstrap/Cargo.toml --verbose --verbose --locked --frozen
Error loading shared library libgcc_s.so.1: No such file or directory (needed by /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo)
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_Resume: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_GetIPInfo: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_GetDataRelBase: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_GetRegionStart: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_SetGR: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_FindEnclosingFunction: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_GetTextRelBase: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_DeleteException: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_RaiseException: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_GetIP: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_Backtrace: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_GetCFA: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_GetLanguageSpecificData: symbol not found
Error relocating /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo: _Unwind_SetIP: symbol not found
Traceback (most recent call last):
  File "/var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rustc-1.63.0-src/./x.py", line 27, in <module>
    bootstrap.main()
  File "/var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rustc-1.63.0-src/src/bootstrap/bootstrap.py", line 1085, in main
    bootstrap(help_triggered)
  File "/var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rustc-1.63.0-src/src/bootstrap/bootstrap.py", line 1061, in bootstrap
    build.build_bootstrap()
  File "/var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rustc-1.63.0-src/src/bootstrap/bootstrap.py", line 803, in build_bootstrap
    run(args, env=env, verbose=self.verbose)
  File "/var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rustc-1.63.0-src/src/bootstrap/bootstrap.py", line 200, in run
    raise RuntimeError(err)
RuntimeError: failed to run: /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rust-stage0/bin/cargo build --manifest-path /var/tmp/portage/dev-lang/rust-1.63.0-r1/work/rustc-1.63.0-src/src/bootstrap/Cargo.toml --verbose --verbose --locked --frozen
 * ERROR: dev-lang/rust-1.63.0-r1::gentoo failed (compile phase):
 *   (no error message)

----

# emerge --info
!!! No gcc found. You probably need to 'source /etc/profile'
!!! to update the environment of this terminal and possibly
!!! other terminals also.
Portage 3.0.36 (python 3.10.7-final-0, default/linux/amd64/17.0/musl/clang, [unavailable], musl-1.2.3-r3, 5.15.67-gentoo-dist-hardened x86_64)
=================================================================
System uname: Linux-5.15.67-gentoo-dist-hardened-x86_64-AMD_Ryzen_9_3950X_16-Core_Processor-with-libc
KiB Mem:    65765036 total,  13162896 free
KiB Swap:    8290300 total,   6447100 free
Timestamp of repository gentoo: Thu, 15 Sep 2022 18:47:03 +0000
sh dash 0.5.11.5
ccache version 4.6.3 [disabled]
app-misc/pax-utils:        1.3.5::gentoo
app-shells/bash:           5.1_p16-r2::gentoo
dev-lang/perl:             5.36.0::gentoo
dev-lang/python:           3.10.7::gentoo, 3.11.0_rc2::gentoo
dev-lang/rust-bin:         1.63.0::x-tmp
dev-util/ccache:           4.6.3::gentoo
dev-util/cmake:            3.24.2::gentoo
dev-util/meson:            0.63.2-r1::gentoo
sys-apps/baselayout:       2.8-r2::gentoo
sys-apps/openrc:           0.45.2::gentoo
sys-apps/sandbox:          2.29::gentoo
sys-devel/autoconf:        2.71-r2::gentoo
sys-devel/automake:        1.16.5::gentoo
sys-devel/binutils:        2.39-r2::gentoo
sys-devel/binutils-config: 5.4.1::gentoo
sys-devel/clang:           13.0.1::gentoo, 14.0.6-r1::gentoo, 15.0.0-r1::gentoo
sys-devel/gcc-config:      2.5-r1::gentoo
sys-devel/libtool:         2.4.7::gentoo
sys-devel/lld:             13.0.1::gentoo
sys-devel/llvm:            13.0.1::gentoo, 14.0.6-r2::gentoo, 15.0.0::gentoo
sys-devel/make:            4.3::gentoo
sys-kernel/linux-headers:  5.19::gentoo (virtual/os-headers)
sys-libs/musl:             1.2.3-r3::gentoo
Repositories:

gentoo
    location: /var/db/repos/gentoo
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-metamanifest: yes
    sync-rsync-verify-jobs: 1
    sync-rsync-extra-opts: 
    sync-rsync-verify-max-age: 24

Installed sets: @sam
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
ADDR2LINE="llvm-addr2line"
AR="llvm-ar"
AS="clang -c"
CBUILD="x86_64-gentoo-linux-musl"
CC="clang"
CFLAGS="-O2 -pipe -march=native -fdiagnostics-color=always -frecord-gcc-switches"
CHOST="x86_64-gentoo-linux-musl"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CPP="clang-cpp"
CXX="clang++"
CXXFLAGS="-O2 -pipe -march=native -fdiagnostics-color=always -frecord-gcc-switches"
DISTDIR="/var/cache/distfiles"
EMERGE_DEFAULT_OPTS="--keep-going=y --complete-graph"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe -march=native -fdiagnostics-color=always -frecord-gcc-switches"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs binpkg-multi-instance buildpkg-live config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox network-sandbox news parallel-fetch parallel-install pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe -march=native -fdiagnostics-color=always -frecord-gcc-switches"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
INSTALL_MASK="charset.alias /usr/share/locale/locale.alias"
LANG="C.UTF8"
LD="ld.lld"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -fuse-ld=lld -rtlib=compiler-rt -unwindlib=libunwind -Wl,--as-needed  -Wl,--defsym=__gentoo_check_ldflags__=0"
NM="llvm-nm"
OBJCOPY="llvm-objcopy"
OBJDUMP="llvm-objdump"
PKGDIR="/var/cache/binpkgs"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
RANLIB="llvm-ranlib"
READELF="llvm-readelf"
STRINGS="llvm-strings"
STRIP="llvm-strip"
USE="acl amd64 bzip2 clang cli crypt dri fortran iconv ipv6 libglvnd libtirpc llvm-libunwind ncurses nls nptl openmp pam pcre readline seccomp split-usr ssl timidity unicode xattr zlib" ABI_X86="64" ADA_TARGET="gnat_2020" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="mmx mmxext sse sse2" ELIBC="musl" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-4 php8-0" POSTGRES_TARGETS="postgres12 postgres13" PYTHON_SINGLE_TARGET="python3_10" PYTHON_TARGETS="python3_10" RUBY_TARGETS="ruby27" USERLAND="GNU" VIDEO_CARDS="amdgpu fbdev intel nouveau radeon radeonsi vesa dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  ARFLAGS, ASFLAGS, CCLD, CONFIG_SHELL, CPPFLAGS, CTARGET, CXXFILT, ELFEDIT, EXTRA_ECONF, F77FLAGS, FC, GCOV, GPROF, LC_ALL, LEX, LFLAGS, LIBTOOL, LINGUAS, MAKE, MAKEFLAGS, MAKEOPTS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, RUSTFLAGS, SHELL, SIZE, YACC, YFLAGS
Comment 1 Larry the Git Cow gentoo-dev 2022-09-16 00:35:16 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=3fa47c76138a86a5d29d30230c0afc1946d46d5b

commit 3fa47c76138a86a5d29d30230c0afc1946d46d5b
Author:     Sam James <sam@gentoo.org>
AuthorDate: 2022-09-16 00:33:02 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2022-09-16 00:35:04 +0000

    profiles/features/clang: add LLVM_USE_LIBCXX, CXXSTDLIB
    
    Needed to build some Rust crates like sys-apps/uutils.
    
    I'd heard some users mention needing to set this but hadn't
    poked particularly far (was in the context of trying to do
    Firefox + libc++ on non-LLVM profiles IIRC).
    
    Bug: https://bugs.gentoo.org/732632
    Bug: https://bugs.gentoo.org/870280
    Thanks-to: Arfrever Frehtes Taifersar Arahesis <Arfrever@Apache.Org>
    Thanks-to: Georgy Yakovlev <gyakovlev@gentoo.org>
    Signed-off-by: Sam James <sam@gentoo.org>

 profiles/features/clang/make.defaults | 3 +++
 1 file changed, 3 insertions(+)
Comment 2 Larry the Git Cow gentoo-dev 2022-09-16 00:46:28 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=941cc3c5faae01bff0045d92e62da0a9689a0358

commit 941cc3c5faae01bff0045d92e62da0a9689a0358
Author:     Georgy Yakovlev <gyakovlev@gentoo.org>
AuthorDate: 2022-09-16 00:17:38 +0000
Commit:     Georgy Yakovlev <gyakovlev@gentoo.org>
CommitDate: 2022-09-16 00:46:12 +0000

    dev-lang/rust: fix bootstrap on musl systems without gcc_s
    
    After extensive debug session we can bootstrap rust with
    upstream tarball on clang-musl-no-gcc system
    
    Thanks-to: Arfrever Frehtes Taifersar Arahesis <Arfrever@Apache.Org>
    Thanks-to: Sam James <sam@gentoo.org>
    Closes: https://bugs.gentoo.org/870280
    Signed-off-by: Georgy Yakovlev <gyakovlev@gentoo.org>

 dev-lang/rust/rust-1.63.0-r1.ebuild | 22 ++++++++++++++++++++++
 1 file changed, 22 insertions(+)
Comment 3 Larry the Git Cow gentoo-dev 2022-09-16 00:55:22 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=9e38708993c9481291726a1bead4e396799b9dba

commit 9e38708993c9481291726a1bead4e396799b9dba
Author:     Sam James <sam@gentoo.org>
AuthorDate: 2022-09-16 00:54:11 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2022-09-16 00:55:14 +0000

    profiles/features/clang: add links for libcxx Rust variables
    
    Bug: https://bugs.gentoo.org/732632
    Bug: https://bugs.gentoo.org/870280
    See: 3fa47c76138a86a5d29d30230c0afc1946d46d5b
    Thanks-to: Arfrever Frehtes Taifersar Arahesis <Arfrever@Apache.Org>
    Signed-off-by: Sam James <sam@gentoo.org>

 profiles/features/clang/make.defaults | 3 +++
 1 file changed, 3 insertions(+)